> ## Documentation Index
> Fetch the complete documentation index at: https://docs-v2.sortx.co.uk/llms.txt
> Use this file to discover all available pages before exploring further.

# Completion

> The contractor's completion report; fixed on a booked visit marks it done



## OpenAPI

````yaml /openapi.json post /p/:tenant/contractor/jobs/{id}/completion
openapi: 3.1.0
info:
  title: SortX API
  version: 1.0.0
  description: >-
    Reactive repairs, planned maintenance, compliance and the repairs desk for
    UK letting agents and property managers.
servers:
  - url: https://api.sortx.co.uk
    description: Production
security: []
tags:
  - name: tenants
  - name: entitlements
  - name: events
  - name: workspace-settings
  - name: operational-catalogues
  - name: money
  - name: contacts
  - name: properties
  - name: address-lookup
  - name: tenancies
  - name: contractor-invoices
  - name: keys
  - name: inspections
  - name: handovers
  - name: planned-maintenance
  - name: contractors
  - name: documents
  - name: compliance
  - name: activity
  - name: tasks
  - name: today
  - name: reports
  - name: workspace-search
  - name: calendar
  - name: telephony
  - name: maintenance-pro
  - name: front-desk
  - name: maintenance-pro-public
  - name: maintenance-pro-contractor
paths:
  /p/:tenant/contractor/jobs/{id}/completion:
    post:
      tags:
        - maintenance-pro-contractor
      summary: Completion
      description: >-
        The contractor's completion report; fixed on a booked visit marks it
        done
      operationId: maintenance-pro-contractor.completion
      parameters:
        - name: id
          in: path
          schema:
            type: string
          required: true
      requestBody:
        content:
          application/json:
            schema:
              type: object
              properties:
                requestId:
                  type: string
                report:
                  type: object
                  properties:
                    outcome:
                      type: string
                    workDone:
                      type: string
                    materials:
                      anyOf:
                        - anyOf:
                            - type: string
                            - type: 'null'
                        - type: 'null'
                    followUpNeeded:
                      anyOf:
                        - type: boolean
                        - type: 'null'
                    followUpNote:
                      anyOf:
                        - anyOf:
                            - type: string
                            - type: 'null'
                        - type: 'null'
                    completedAt:
                      anyOf:
                        - anyOf:
                            - type: string
                            - type: 'null'
                        - type: 'null'
                    reasons:
                      anyOf:
                        - type: array
                          items:
                            type: string
                        - type: 'null'
                  required:
                    - outcome
                    - workDone
                  additionalProperties: false
                photoAttachmentIds:
                  anyOf:
                    - type: array
                      items:
                        type: string
                    - type: 'null'
                nextStep:
                  anyOf:
                    - anyOf:
                        - type: object
                          properties:
                            parts:
                              anyOf:
                                - anyOf:
                                    - type: object
                                      properties:
                                        part:
                                          type: string
                                        supplier:
                                          anyOf:
                                            - anyOf:
                                                - type: string
                                                - type: 'null'
                                            - type: 'null'
                                        ordered:
                                          type: boolean
                                        expectedOn:
                                          type: string
                                        costMinor:
                                          anyOf:
                                            - anyOf:
                                                - anyOf:
                                                    - type: number
                                                    - type: string
                                                      enum:
                                                        - Infinity
                                                        - '-Infinity'
                                                        - NaN
                                                - type: 'null'
                                            - type: 'null'
                                        returnDurationMinutes:
                                          anyOf:
                                            - type: number
                                            - type: string
                                              enum:
                                                - Infinity
                                                - '-Infinity'
                                                - NaN
                                      required:
                                        - part
                                        - ordered
                                        - expectedOn
                                        - returnDurationMinutes
                                      additionalProperties: false
                                    - type: 'null'
                                - type: 'null'
                            quote:
                              anyOf:
                                - anyOf:
                                    - type: object
                                      properties:
                                        lines:
                                          type: array
                                          items:
                                            type: object
                                            properties:
                                              description:
                                                type: string
                                              amountMinor:
                                                anyOf:
                                                  - type: number
                                                  - type: string
                                                    enum:
                                                      - Infinity
                                                      - '-Infinity'
                                                      - NaN
                                            required:
                                              - description
                                              - amountMinor
                                            additionalProperties: false
                                        totalMinor:
                                          anyOf:
                                            - type: number
                                            - type: string
                                              enum:
                                                - Infinity
                                                - '-Infinity'
                                                - NaN
                                        vatMinor:
                                          anyOf:
                                            - anyOf:
                                                - anyOf:
                                                    - type: number
                                                    - type: string
                                                      enum:
                                                        - Infinity
                                                        - '-Infinity'
                                                        - NaN
                                                - type: 'null'
                                            - type: 'null'
                                        earliestStartOn:
                                          anyOf:
                                            - anyOf:
                                                - type: string
                                                - type: 'null'
                                            - type: 'null'
                                      required:
                                        - lines
                                        - totalMinor
                                      additionalProperties: false
                                    - type: 'null'
                                - type: 'null'
                            hazard:
                              anyOf:
                                - anyOf:
                                    - type: object
                                      properties:
                                        description:
                                          type: string
                                        madeSafe:
                                          type: boolean
                                        anyoneAtRisk:
                                          type: boolean
                                      required:
                                        - description
                                        - madeSafe
                                        - anyoneAtRisk
                                      additionalProperties: false
                                    - type: 'null'
                                - type: 'null'
                            returnVisit:
                              anyOf:
                                - anyOf:
                                    - type: object
                                      properties:
                                        needed:
                                          type: string
                                        timeNeededMinutes:
                                          anyOf:
                                            - anyOf:
                                                - anyOf:
                                                    - type: number
                                                    - type: string
                                                      enum:
                                                        - Infinity
                                                        - '-Infinity'
                                                        - NaN
                                                - type: 'null'
                                            - type: 'null'
                                        returnBy:
                                          anyOf:
                                            - anyOf:
                                                - type: string
                                                - type: 'null'
                                            - type: 'null'
                                      required:
                                        - needed
                                      additionalProperties: false
                                    - type: 'null'
                                - type: 'null'
                            photoDocumentIds:
                              anyOf:
                                - type: array
                                  items:
                                    type: string
                                - type: 'null'
                          additionalProperties: false
                        - type: 'null'
                    - type: 'null'
                otherTrade:
                  anyOf:
                    - anyOf:
                        - type: object
                          properties:
                            trade:
                              type: string
                            purpose:
                              type: string
                            safeMeanwhile:
                              type: boolean
                            currentFinishes:
                              type: boolean
                          required:
                            - trade
                            - purpose
                            - safeMeanwhile
                            - currentFinishes
                          additionalProperties: false
                        - type: 'null'
                    - type: 'null'
              required:
                - requestId
                - report
              additionalProperties: false
        required: true
      responses:
        '200':
          description: Success
          content:
            application/json:
              schema:
                type: object
                properties:
                  id:
                    type: string
                  kind:
                    type: string
                  visitStartsAt:
                    anyOf:
                      - type: string
                      - type: 'null'
                  expectedAt:
                    anyOf:
                      - type: string
                      - type: 'null'
                  note:
                    anyOf:
                      - type: string
                      - type: 'null'
                  outcome:
                    anyOf:
                      - type: string
                      - type: 'null'
                  workDone:
                    anyOf:
                      - type: string
                      - type: 'null'
                  materials:
                    anyOf:
                      - type: string
                      - type: 'null'
                  followUpNeeded:
                    anyOf:
                      - type: boolean
                      - type: 'null'
                  followUpNote:
                    anyOf:
                      - type: string
                      - type: 'null'
                  photoAttachmentIds:
                    type: array
                    items:
                      type: string
                  reasons:
                    anyOf:
                      - type: array
                        items:
                          type: string
                      - type: 'null'
                  occurredAt:
                    type: string
                  recordedAt:
                    type: string
                required:
                  - id
                  - kind
                  - visitStartsAt
                  - expectedAt
                  - note
                  - outcome
                  - workDone
                  - materials
                  - followUpNeeded
                  - followUpNote
                  - photoAttachmentIds
                  - occurredAt
                  - recordedAt
                additionalProperties: false
        '400':
          description: >-
            TenantCreateRejected | ConfigMissing | IntegrationRejected |
            AuthRejected | RegistrationRejected | UnknownIntegration |
            WebhookUnroutable | RateUnavailable | MaintenanceRepairInvalid
          content:
            application/json:
              schema:
                anyOf:
                  - $ref: '#/components/schemas/TenantCreateRejectedEncoded'
                  - $ref: '#/components/schemas/ConfigMissingEncoded'
                  - $ref: '#/components/schemas/IntegrationRejectedEncoded'
                  - $ref: '#/components/schemas/AuthRejectedEncoded'
                  - $ref: '#/components/schemas/RegistrationRejectedEncoded'
                  - $ref: '#/components/schemas/UnknownIntegrationEncoded'
                  - $ref: '#/components/schemas/WebhookUnroutableEncoded'
                  - $ref: '#/components/schemas/RateUnavailableEncoded'
                  - $ref: '#/components/schemas/MaintenanceRepairInvalidEncoded'
        '401':
          description: Unauthenticated | WebhookRejected | ApiKeyRejected
          content:
            application/json:
              schema:
                anyOf:
                  - $ref: '#/components/schemas/UnauthenticatedEncoded'
                  - $ref: '#/components/schemas/WebhookRejectedEncoded'
                  - $ref: '#/components/schemas/ApiKeyRejectedEncoded'
        '402':
          description: TenantSuspended
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/TenantSuspendedEncoded'
        '403':
          description: >-
            EntitlementMissing | NotAMember | ScopeUnknown | ScopeMissing |
            TenantMismatch | ContractorAccessDenied
          content:
            application/json:
              schema:
                anyOf:
                  - $ref: '#/components/schemas/EntitlementMissingEncoded'
                  - $ref: '#/components/schemas/NotAMemberEncoded'
                  - $ref: '#/components/schemas/ScopeUnknownEncoded'
                  - $ref: '#/components/schemas/ScopeMissingEncoded'
                  - $ref: '#/components/schemas/TenantMismatchEncoded'
                  - $ref: '#/components/schemas/ContractorAccessDeniedEncoded'
        '404':
          description: TenantNotFound | ModuleRequestNotFound | MaintenanceRepairNotFound
          content:
            application/json:
              schema:
                anyOf:
                  - $ref: '#/components/schemas/TenantNotFoundEncoded'
                  - $ref: '#/components/schemas/ModuleRequestNotFoundEncoded'
                  - $ref: '#/components/schemas/MaintenanceRepairNotFoundEncoded'
        '409':
          description: WebhookDuplicate | RegistrationConflict | MaintenanceRepairConflict
          content:
            application/json:
              schema:
                anyOf:
                  - $ref: '#/components/schemas/WebhookDuplicateEncoded'
                  - $ref: '#/components/schemas/RegistrationConflictEncoded'
                  - $ref: '#/components/schemas/MaintenanceRepairConflictEncoded'
        '429':
          description: RateLimited
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/RateLimitedEncoded'
        '503':
          description: IntegrationUnavailable
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/IntegrationUnavailableEncoded'
      security: []
components:
  schemas:
    TenantCreateRejectedEncoded:
      type: object
      properties:
        _tag:
          type: string
          enum:
            - TenantCreateRejected
        reason:
          type: string
        field:
          anyOf:
            - type: string
            - type: 'null'
      required:
        - _tag
        - reason
      additionalProperties: false
    ConfigMissingEncoded:
      type: object
      properties:
        _tag:
          type: string
          enum:
            - ConfigMissing
        key:
          type: string
      required:
        - _tag
        - key
      additionalProperties: false
    IntegrationRejectedEncoded:
      type: object
      properties:
        _tag:
          type: string
          enum:
            - IntegrationRejected
        integration:
          type: string
        reason:
          type: string
      required:
        - _tag
        - integration
        - reason
      additionalProperties: false
    AuthRejectedEncoded:
      type: object
      properties:
        _tag:
          type: string
          enum:
            - AuthRejected
        code:
          type: string
        message:
          type: string
      required:
        - _tag
        - code
        - message
      additionalProperties: false
    RegistrationRejectedEncoded:
      type: object
      properties:
        _tag:
          type: string
          enum:
            - RegistrationRejected
        message:
          type: string
        field:
          anyOf:
            - type: string
            - type: 'null'
      required:
        - _tag
        - message
      additionalProperties: false
    UnknownIntegrationEncoded:
      type: object
      properties:
        _tag:
          type: string
          enum:
            - UnknownIntegration
        integration:
          type: string
      required:
        - _tag
        - integration
      additionalProperties: false
    WebhookUnroutableEncoded:
      type: object
      properties:
        _tag:
          type: string
          enum:
            - WebhookUnroutable
        integration:
          type: string
        reason:
          type: string
      required:
        - _tag
        - integration
        - reason
      additionalProperties: false
    RateUnavailableEncoded:
      type: object
      properties:
        _tag:
          type: string
          enum:
            - RateUnavailable
        base:
          type: string
        quote:
          type: string
        'on':
          type: string
      required:
        - _tag
        - base
        - quote
        - 'on'
      additionalProperties: false
    MaintenanceRepairInvalidEncoded:
      type: object
      properties:
        _tag:
          type: string
          enum:
            - MaintenanceRepairInvalid
        reason:
          type: string
      required:
        - _tag
        - reason
      additionalProperties: false
    UnauthenticatedEncoded:
      type: object
      properties:
        _tag:
          type: string
          enum:
            - Unauthenticated
      required:
        - _tag
      additionalProperties: false
    WebhookRejectedEncoded:
      type: object
      properties:
        _tag:
          type: string
          enum:
            - WebhookRejected
        integration:
          type: string
        reason:
          type: string
      required:
        - _tag
        - integration
        - reason
      additionalProperties: false
    ApiKeyRejectedEncoded:
      type: object
      properties:
        _tag:
          type: string
          enum:
            - ApiKeyRejected
      required:
        - _tag
      additionalProperties: false
    TenantSuspendedEncoded:
      type: object
      properties:
        _tag:
          type: string
          enum:
            - TenantSuspended
        tenantId:
          type: string
        reason:
          type: string
      required:
        - _tag
        - tenantId
        - reason
      additionalProperties: false
    EntitlementMissingEncoded:
      type: object
      properties:
        _tag:
          type: string
          enum:
            - EntitlementMissing
        tenantId:
          type: string
        moduleId:
          type: string
      required:
        - _tag
        - tenantId
        - moduleId
      additionalProperties: false
    NotAMemberEncoded:
      type: object
      properties:
        _tag:
          type: string
          enum:
            - NotAMember
        userId:
          type: string
        slug:
          type: string
      required:
        - _tag
        - userId
        - slug
      additionalProperties: false
    ScopeUnknownEncoded:
      type: object
      properties:
        _tag:
          type: string
          enum:
            - ScopeUnknown
        scope:
          type: string
      required:
        - _tag
        - scope
      additionalProperties: false
    ScopeMissingEncoded:
      type: object
      properties:
        _tag:
          type: string
          enum:
            - ScopeMissing
        scope:
          type: string
      required:
        - _tag
        - scope
      additionalProperties: false
    TenantMismatchEncoded:
      type: object
      properties:
        _tag:
          type: string
          enum:
            - TenantMismatch
        header:
          type: string
        organizationId:
          type: string
      required:
        - _tag
        - header
        - organizationId
      additionalProperties: false
    ContractorAccessDeniedEncoded:
      type: object
      properties:
        _tag:
          type: string
          enum:
            - ContractorAccessDenied
      required:
        - _tag
      additionalProperties: false
    TenantNotFoundEncoded:
      type: object
      properties:
        _tag:
          type: string
          enum:
            - TenantNotFound
        slug:
          type: string
      required:
        - _tag
        - slug
      additionalProperties: false
    ModuleRequestNotFoundEncoded:
      type: object
      properties:
        _tag:
          type: string
          enum:
            - ModuleRequestNotFound
        id:
          type: string
      required:
        - _tag
        - id
      additionalProperties: false
    MaintenanceRepairNotFoundEncoded:
      type: object
      properties:
        _tag:
          type: string
          enum:
            - MaintenanceRepairNotFound
        resource:
          type: string
        id:
          type: string
      required:
        - _tag
        - resource
        - id
      additionalProperties: false
    WebhookDuplicateEncoded:
      type: object
      properties:
        _tag:
          type: string
          enum:
            - WebhookDuplicate
        integration:
          type: string
        externalId:
          type: string
      required:
        - _tag
        - integration
        - externalId
      additionalProperties: false
    RegistrationConflictEncoded:
      type: object
      properties:
        _tag:
          type: string
          enum:
            - RegistrationConflict
        message:
          type: string
        field:
          anyOf:
            - type: string
            - type: 'null'
      required:
        - _tag
        - message
      additionalProperties: false
    MaintenanceRepairConflictEncoded:
      type: object
      properties:
        _tag:
          type: string
          enum:
            - MaintenanceRepairConflict
        reason:
          type: string
      required:
        - _tag
        - reason
      additionalProperties: false
    RateLimitedEncoded:
      type: object
      properties:
        _tag:
          type: string
          enum:
            - RateLimited
        key:
          type: string
        retryAfterSeconds:
          anyOf:
            - type: number
            - type: string
              enum:
                - Infinity
                - '-Infinity'
                - NaN
        message:
          type: string
      required:
        - _tag
        - key
        - retryAfterSeconds
        - message
      additionalProperties: false
    IntegrationUnavailableEncoded:
      type: object
      properties:
        _tag:
          type: string
          enum:
            - IntegrationUnavailable
        integration:
          type: string
        detail:
          anyOf:
            - type: string
            - type: 'null'
      required:
        - _tag
        - integration
      additionalProperties: false

````

This documentation is built and hosted on [Mintlify](https://mintlify.com), a developer documentation platform.